import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Car here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Car extends SmoothMover
{
    public static final double MAX_SPEED = 3;
    public static final double MAX_ACCELARATION = 5;
    public static final double MAX_BREAKING = 5;
    public static final int MAX_TURN = 5;
    
    double speed = 0;
    double acceleration = 0.1;
    double breaking = 0.1;
    int turnspeed = 2;
    
    Color trackcolour;
    boolean inoil = false;
    String left,right,up,down;
    
    public Car (int r, int g, int b,String left, String right, String up, String down){
        trackcolour = new Color(r,g,b);
        this.left = left;
        this.right = right;
        this.up = up;
        this.down = down;
    }
    
    public void checkMovement() {
        if (Greenfoot.isKeyDown(up) && speed < MAX_SPEED) {
            speed = speed + acceleration;
        }
        if (Greenfoot.isKeyDown(down) && !inoil && speed > -MAX_SPEED) {
            speed = speed - breaking;
        }
        if (Greenfoot.isKeyDown(left)) {
            turn(-turnspeed);
        }
        if (Greenfoot.isKeyDown(right)) {
            turn(turnspeed);
        }
    }
    
    public void checkonTrack(){
        World world = getWorld();
        //System.out.println(world.getBackground().getColorAt(getX(),getY()));
        if (!world.getBackground().getColorAt(getX(),getY()).equals(trackcolour))
        {
            if (speed>0) {
                move(-1);
            }
            else {
                move(1);
            }
            speed = 0;
        }
        
        }
    public void checkInOil(){
        if (isTouching(OilSpil.class)){
            turn(Greenfoot.getRandomNumber(1)-2);
            inoil=true;
        }
        else {
            inoil = false;
        }
        }
    
    public void testForCarCollision(){
        Actor car = getOneIntersectingObject(Car.class);
        if (car !=null){
        double otherCarX = car.getX();
        double otherCarY = car.getY();
        
        double angle = Math.atan2(otherCarY - getY(), otherCarX - getX());
        if (angle > 0) {
            turn(-2);
        }
        else if (angle < 0 ){
            turn(2);
        }
    }
    }
    
    /**
     * Act - do whatever the Car wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        checkMovement();
        checkonTrack();
        checkInOil();
        move(speed);
        testForCarCollision();// Add
        
    }
    
}
