import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{
    public static final int SPANNER_SPAWN_TIME = 2000;
    public static final int SPANNER_SPAWN_TIMEOUT =1000;
    private int spannercounter;

    private Counter counterPlayer1CurrentLap = new Counter();
    private Counter counterPlayer1BestLap = new Counter();
    private Counter counterLap = new Counter();
    private Counter counterLastLap = new Counter();

    private Counter counterPlayer2CurrentLap = new Counter();
    private Counter counterPlayer2BestLap = new Counter();
    private Counter counterPlayer2Lap = new Counter();
    private Counter counterPlayer2LastLap = new Counter();

    private double timeToBeat = 50.00;

    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(1000, 750, 1);

        addObject(new StartLine(),316,53);
        addObject(new OilSpil(),765,67);
        addObject(new CheckPoint(1), 309,50);
        addObject(new CheckPoint(2), 598,670);
        addObject(new Sand(), 517, 642);
        addObject(new Car(77,77,77,"left","right","up","down",1),288,67);
        addObject(new Car(77,77,77,"a","d","w","s",2),288,37);
        addObject(new Bridge(),607,200);
        addObject(new Scoreboard(),625,569);

        addObject(counterPlayer1CurrentLap,585,565);
        counterPlayer1CurrentLap.setValue(0);
        addObject(counterPlayer1BestLap, 585, 603);
        addObject(counterLap, 502, 603);
        addObject(counterLastLap,502,565);

        addObject(counterPlayer2CurrentLap,752,565);
        counterPlayer2CurrentLap.setValue(0);
        addObject(counterPlayer2BestLap, 752, 603);
        addObject(counterPlayer2Lap, 668, 603);
        addObject(counterPlayer2LastLap,668,565);

        prepare();
    }

    public void displayLastLaptime(double laptime, double bestlap, int playerno, int lapno){
        if (playerno == 1) {
            counterLastLap.setValue((int)laptime);
            counterPlayer1BestLap.setValue((int)bestlap);
            counterLap.setValue(lapno);
        }
        else if (playerno == 2) {
            counterPlayer2LastLap.setValue((int)laptime);
            counterPlayer2BestLap.setValue((int)bestlap);
            counterPlayer2Lap.setValue(lapno);
        }

    }

    public void displayLaptime(double laptime, int playerno) {
        if (playerno == 1){
            counterPlayer1CurrentLap.setValue((int)laptime);
        }
        else if (playerno == 2) {
            counterPlayer2CurrentLap.setValue((int)laptime);
        }
    }

    private void addSpanner() {
        int place = Greenfoot.getRandomNumber(5);
        if (place == 0) {
            addObject(new Spanner(SPANNER_SPAWN_TIMEOUT),788,73);
        }
        else if (place == 1) {
            addObject(new Spanner(SPANNER_SPAWN_TIMEOUT),436,177);
        }
        else if (place == 2) {
            addObject(new Spanner(SPANNER_SPAWN_TIMEOUT),827,480);
        }
        else if (place == 3) {
            addObject(new Spanner(SPANNER_SPAWN_TIMEOUT),426,636);
        }
        else if (place == 4) {
            addObject(new Spanner(SPANNER_SPAWN_TIMEOUT),127,41);
        }
    }

    private void spannerRewardsAdd(){
        spannercounter ++;
        if (spannercounter > SPANNER_SPAWN_TIME){
            spannercounter = 0;
            addSpanner();

        }
    }

    
    public void act(){
        spannerRewardsAdd();

    }
    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
    }
}
